<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegB376 extends Record {
    /**
     * @var array Lista de colunas esperadas para o bloco
     */   
    protected $templateColumns = null;

    public function __construct($values = null) {
        
    }

    public function load($recordString) {
        $subtype = substr($recordString, 4, 1);
        switch($subtype) {
            case '1':
                $this->templateColumns = $this->subType1;
                break;
            case '2':
                $this->templateColumns = $this->subType2;
                break;
            default: 
                throw new \Exception("Subtipo '$subtype' não existe para o bloco 'B376'");
        }

        $this->createColumns();
        parent::load($recordString);
    }

    private $subType1 = [
        
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type",
            'position' => 5,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "type_doc",
            'position' => 6,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "desc_type_doc",
            'position' => 7,
            'size' => 6,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "number_doc",
            'position' => 13,
            'size' => 20,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "date_occur",
            'position' => 33,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "reason_occur",
            'position' => 43,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "ddd_contact",
            'position' => 53,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "phone_contact",
            'position' => 56,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler_1",
            'position' => 65,
            'size' => 50,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];
    
    private $subType2 = [
        
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type",
            'position' => 5,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "message",
            'position' => 6,
            'size' => 65,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "reduced_message",
            'position' => 71,
            'size' => 32,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler_1",
            'position' => 103,
            'size' => 12,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];
}