<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks;

use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN230_00;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN230_90;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN230_99;
use Schaffen\SerasaRemessa\Utils\Record;

class RegN230 extends Record {
    protected $values;
    
    protected $blockCodeSubType;

    public $subtypeInstance;

    public function __construct($values = null, $blockCodeSubType = null) {
        $this->values = $values;
        $this->blockCodeSubType = $blockCodeSubType;

        switch ($blockCodeSubType) {
            case '00':
                $this->subtypeInstance = new SubTypeN230_00($values);
                break;
            case '90':
                $this->subtypeInstance = new SubTypeN230_90($values);
                break;
            case '99':
                $this->subtypeInstance = new SubTypeN230_99($values);
                break;
            default:
                $this->subtypeInstance = new SubTypeN230_00($values);
                break;
        }
    }

    public function getValues() {
        return $this->subtypeInstance->getValues();
    }
}