<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeN440_02 extends Record {
    public $name = "check_inquires_internal";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type_rule",
            'position' => 5,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "rc_nome1",
            'position' => 7,
            'size' => 25,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "rc_data1",
            'position' => 32,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "rc_nome2",
            'position' => 36,
            'size' => 25,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "rc_data2",
            'position' => 61,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "rc_nome3",
            'position' => 65,
            'size' => 25,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "rc_data3",
            'position' => 90,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 94,
            'size' => 71,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ]
    ];

    public function __construct($values = null) {
        $this->createColumns();

        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['sub_type_rule'] = substr($values, 4, 2);
        $newValues['rc_nome1'] = substr($values, 6, 25);
        $newValues['rc_data1'] = substr($values, 31, 4);
        $newValues['rc_nome2'] = substr($values, 35, 25);
        $newValues['rc_data2'] = substr($values, 60, 4);
        $newValues['rc_nome3'] = substr($values, 64, 25);
        $newValues['rc_data3'] = substr($values, 89, 4);
        $newValues['filler'] = substr($values, 93, 71);
        
        $this->setColumnsValues($newValues);
    }   
}